#include <fcntl.h>
#include <stdio.h>
#include <sys/ioctl.h>
#include <unistd.h>

int main()
{
    int fd = open("/dev/fb0", O_WRONLY | O_CLOEXEC);
    if (fd < 0)
    {
        perror("open");
        return 1;
    }

    int fb_width = ioctl(fd, FB_GET_WIDTH);
    if (fb_width < 0)
    {
        perror("ioctl(FB_GET_WIDTH)");
        return 1;
    }

    int fb_height = ioctl(fd, FB_GET_HEIGHT);
    if (fb_height < 0)
    {
        perror("ioctl(FB_GET_HEIGHT)");
        return 1;
    }

    printf("Your screen is %dx%d\n", fb_width, fb_height);

    close(fd);
}