#include <ctype.h>

extern "C"
{
    int isalnum(int c)
    {
        return isalpha(c) || isdigit(c);
    }

    int isalpha(int c)
    {
        return islower(c) || isupper(c);
    }

    int isascii(int c)
    {
        return !(c & ~0x7f);
    }

    int isblank(int c)
    {
        return c == ' ' || c == '\t';
    }

    int iscntrl(int c)
    {
        return (unsigned int)c < 0x20 || c == 0x7f;
    }

    int isdigit(int c)
    {
        return c >= '0' && c < ':';
    }

    int isgraph(int c)
    {
        return (unsigned int)c - 0x21 < 0x5e;
    }

    int islower(int c)
    {
        return c >= 'a' && c < '{';
    }

    int isprint(int c)
    {
        return (unsigned int)c - 0x20 < 0x5f;
    }

    int ispunct(int c)
    {
        return isgraph(c) && !isalnum(c);
    }

    int isspace(int c)
    {
        return c == ' ' || (unsigned int)c - '\t' < 5;
    }

    int isupper(int c)
    {
        return c >= 'A' && c < '[';
    }

    int isxdigit(int c)
    {
        return isdigit(c) || ((unsigned int)c | 32) - 'a' < 6;
    }

    int tolower(int c)
    {
        if (isupper(c)) return c | 32;
        return c;
    }

    int toupper(int c)
    {
        if (islower(c)) return c & 0x5f;
        return c;
    }

    int toascii(int c)
    {
        return c & 0x7f;
    }
}